using System.Collections.Generic;
using System.Linq;
using System.Text;
using Android.Net;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.Provider;
using Android.App;

namespace android.os
{
    public class _Contacts
    {
        public string Name { get; set; }
        public string Number { get; set; }
    }
    public static class Contacts
    {
        private static string[] prjc = {ContactsContract.Contacts.InterfaceConsts.DisplayName, ContactsContract.CommonDataKinds.Phone.Number, ContactsContract.Contacts.InterfaceConsts.Id };
        private static Uri uri = ContactsContract.CommonDataKinds.Phone.ContentUri;
        private static Uri profuri = ContactsContract.Profile.ContentUri;
        private static List<_Contacts> _Contacts(Android.Database.ICursor Cur)
        {
            List<_Contacts> cons = new List<_Contacts>();
            if (Cur.MoveToFirst())
            {
                do
                {
                    cons.Add(new _Contacts
                    {
                        Name = Cur.GetString(Cur.GetColumnIndex(ContactsContract.Contacts.InterfaceConsts.DisplayName)),
                        Number = Cur.GetString(Cur.GetColumnIndex(ContactsContract.CommonDataKinds.Phone.Number))
                    });
                } while (Cur.MoveToNext());
            }
            Cur.Close();
            return cons;
        }
        public static List<_Contacts> All()
        {
            var cursor = Application.Context.ContentResolver.Query(uri, null, null, null, null);
            return _Contacts(cursor);
        }
        public static string number_to_name(string number)
        {
            List<_Contacts> contacts = All();
            for (int i = 0; i < contacts.Count; i++)
                if (inf.Metods.Trim(contacts[i].Number) == inf.Metods.Trim(number))
                    return contacts[i].Name;
            return "";
        }
        public static List<string> name_to_numbers(string name)
        {
            List<_Contacts> contacts = All();
            List<string> returnnums = new List<string>();
            for (int i = 0; i < contacts.Count; i++)
                if (inf.Metods.Trim(contacts[i].Name.ToLower()) == inf.Metods.Trim(name.ToLower()))
                    returnnums.Add(contacts[i].Number);
            return returnnums;
        }
    }
}