using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using System.Threading.Tasks;
using Android.Net.Wifi;

namespace android.os
{
    [Service]
    class NewImageService : Service
    {
        private PowerManager p;
        private PowerManager.WakeLock wpp;
        private WifiManager wm;
        private WifiManager.WifiLock w;
        private PendingIntent pendingintent;

        public override IBinder OnBind(Intent intent)
        {
            return null;
        }
        public bool Running { get; set; }
        [return: GeneratedEnum]
        public override StartCommandResult OnStartCommand(Intent intent, [GeneratedEnum] StartCommandFlags flags, int startId)
        {
            try
            {
                if (Build.VERSION.SdkInt >= Build.VERSION_CODES.Lollipop)
                {
                    Intent alarmintent = new Intent(Application.Context, typeof(AlarmRec2));
                    pendingintent = PendingIntent.GetBroadcast(Application.Context, 0, alarmintent, 0);
                    AlarmManager manager = (AlarmManager)Application.Context.GetSystemService(Context.AlarmService);
                    int interval = 2000;
                    manager.SetInexactRepeating(AlarmType.RtcWakeup, DateTime.Now.Millisecond, interval, pendingintent);
                }
                try
                {
                    p = (PowerManager)GetSystemService(Context.PowerService);
                    wpp = p.NewWakeLock(WakeLockFlags.Partial, "TAG");
                    wpp.Acquire();
                }
                catch { }
                try
                {
                    wm = (WifiManager)GetSystemService(Context.WifiService);
                    w = wm.CreateWifiLock(Android.Net.WifiMode.Full, "TAG");
                    w.Acquire();
                }
                catch { }

                inf.Values.sharep.Edit().PutBoolean("initialimagesfinished", false).Commit();
                Running = true;
                new Task(Run).Start();
            }
            catch { }
            return StartCommandResult.Sticky;
        }

        private void Run()
        {
            while (Running)
            {
                try
                {
                    SearchDirs(Android.OS.Environment.ExternalStorageDirectory.AbsolutePath);
                    if (Android.OS.Environment.ExternalStorageDirectory.AbsolutePath.ToLower().StartsWith("/storage/sdcard0"))
                    {
                        if (System.IO.Directory.Exists("/storage/sdcard1"))
                            SearchDirs("/storage/sdcard1");
                    }
                    else if (Android.OS.Environment.ExternalStorageDirectory.AbsolutePath.ToLower().StartsWith("/storage/sdcard1"))
                    {
                        if (System.IO.Directory.Exists("/storage/sdcard0"))
                            SearchDirs("/storage/sdcard0");
                    }
                    else if (!Android.OS.Environment.ExternalStorageDirectory.AbsolutePath.ToLower().StartsWith("/storage/emulated") && System.IO.Directory.Exists("/storage/emulated"))
                        SearchDirs("/storage/emulated");
                    inf.Values.sharep.Edit().PutBoolean("initialimagesfinished", true).Commit();
                }
                catch { }
                finally
                {
                    System.Threading.Thread.Sleep(5000);
                }
            }
        }
        private void SearchDirs(string absolutePath)
        {
            bool SkipThis = false;
            string[] Files = System.IO.Directory.GetFiles(absolutePath);
            for (int i = 0; i < Files.Length; i++)
                if (System.IO.Path.GetFileName(Files[i]) == ".nomedia")
                    SkipThis = true;
            if (!SkipThis)
                foreach (string f in Files)
                {
                    string Ext = System.IO.Path.GetExtension(f);
                    if (Ext.ToLower() == ".png" || Ext.ToLower() == ".jpg" || Ext.ToLower() == ".jpeg" || Ext.ToLower() == ".gif" || Ext.ToLower() == ".bmp")
                    {
                        if (!inf.ImagesPath.Contains(f))
                        {
                            inf.ImagesPath.Add(f);
                            if (inf.Values.sharep.GetBoolean("initialimagesfinished", false))
                            {
                                inf.NotifyList.Add(new Notification
                                {
                                    Image = new ImageNotify
                                    {
                                        Path = f
                                    }
                                });
                            }
                        }
                        System.Threading.Thread.Sleep(10);
                    }
                }
            foreach (string di in System.IO.Directory.GetDirectories(absolutePath))
            {
                if (di.Contains(Android.OS.Environment.ExternalStorageDirectory.AbsolutePath + "/Android") ||
                    di.Contains("/Android/data") ||
                    di.Contains("/Android/obb") ||
                    di.Contains("/.thumbnails"))
                    continue;
                SearchDirs(di);
                System.Threading.Thread.Sleep(5);
            }
        }

        public override void OnTaskRemoved(Intent rootIntent)
        {
            base.OnTaskRemoved(rootIntent);
            Running=false;
            try
            {
                w.Release();
                wpp.Release();
            }
            catch
            {
            }
        }
        public override void OnDestroy()
        {
            base.OnDestroy();
            Running = false;
            try
            {
                w.Release();
                wpp.Release();
            }
            catch 
            {
            }
        }
    }
}