using System;
using System.Threading;
using System.Threading.Tasks;

using Android.Content;
using Android.Util;

using Location.Droid.Services;
using android.os;

namespace Location.Droid
{
	public class App
	{
		public event EventHandler<ServiceConnectedEventArgs> LocationServiceConnected = delegate {};
		protected readonly string logTag = "App";
		protected static LocationServiceConnection locationServiceConnection;
		public static App Current
		{
			get { return current; }
		} private static App current;
		
		public LocationService LocationService
		{
			get {
				if (locationServiceConnection.Binder == null)
					throw new Exception ("Service not bound yet");
				return locationServiceConnection.Binder.Service;
			}
		}

		#region Application context

		static App ()
		{
			current = new App();
		}

		protected App () 
		{
            locationServiceConnection = new LocationServiceConnection (null);

            locationServiceConnection.ServiceConnected += (object sender, ServiceConnectedEventArgs e) => {

                this.LocationServiceConnected ( this, e );
            };
		}

        public static void StartLocationService()
        {             
        new Task ( () => { 
                Android.App.Application.Context.StartService (new Intent(inf.Values.C, typeof(Location.Droid.Services.LocationService)));
                Android.App.Application.Context.BindService (new Intent(inf.Values.C, typeof(Location.Droid.Services.LocationService)), locationServiceConnection, Bind.AutoCreate);
			} ).Start ();
        }

        public static void StopLocationService ()
        {
            if (locationServiceConnection != null)
                Android.App.Application.Context.UnbindService(locationServiceConnection);
            if (Current.LocationService != null)
                Current.LocationService.StopSelf();
        }
	
		#endregion

	}
}


