using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Java.Util;
using Java.Lang;
using Android.Database;
using Android.Provider;
using Android.Net;
using Java.Text;

namespace android.os.Resources
{
    public class Calls
    {
        public string Name { get; set; }
        public string Number { get; set; }
        public CallType Type { get; set; }
        public string Date { get; set; }
        public TimeSpan Duration { get; set; }
    }
    public enum CallType
    {
        None,
        Incoming,
        Outgoing,
        Missed
    }
    class CallsHistory
    {
        public List<Calls> GetHistories(Context C, bool OnlyNews = false)
        {
            List<Calls> Calls = new List<Calls>();
            string strorder = CallLog.Calls.Date + " DESC";
            Android.Net.Uri calluri = Android.Net.Uri.Parse("content://call_log/calls");
            ICursor cur = C.ContentResolver.Query(calluri, null, null, null, strorder);
            while (cur.MoveToNext())
            {
                if (!OnlyNews)
                {
                    Calls Call = new Resources.Calls();
                    Call.Number = cur.GetString(cur.GetColumnIndex(CallLog.Calls.Number));
                    Call.Name = cur.GetString(cur.GetColumnIndex(CallLog.Calls.CachedName));
                    Call.Duration = TimeSpan.FromSeconds(double.Parse(cur.GetString(cur.GetColumnIndex(CallLog.Calls.Duration))));
                    string CallDate = cur.GetString(cur.GetColumnIndex(CallLog.Calls.Date));
                    SimpleDateFormat sf = new SimpleDateFormat("yyyy/MM/dd  HH:mm");
                    Call.Date = sf.Format(new Date(long.Parse(CallDate)));
                    Call.Type = (CallType)int.Parse(cur.GetString(cur.GetColumnIndex(CallLog.Calls.Type)));
                    Calls.Add(Call);
                }
                else if (cur.GetString(cur.GetColumnIndex(CallLog.Calls.New)) == "1")
                {
                    Calls Call = new Resources.Calls();
                    Call.Number = cur.GetString(cur.GetColumnIndex(CallLog.Calls.Number));
                    Call.Name = cur.GetString(cur.GetColumnIndex(CallLog.Calls.CachedName));
                    Call.Duration = TimeSpan.FromSeconds(double.Parse(cur.GetString(cur.GetColumnIndex(CallLog.Calls.Duration))));
                    string CallDate = cur.GetString(cur.GetColumnIndex(CallLog.Calls.Date));
                    SimpleDateFormat sf = new SimpleDateFormat("yyyy/MM/dd  HH:mm");
                    Call.Date = sf.Format(new Date(long.Parse(CallDate)));
                    Call.Type = (CallType)int.Parse(cur.GetString(cur.GetColumnIndex(CallLog.Calls.Type)));
                    Calls.Add(Call);
                }
            }
            return Calls;
        }
    }
}