using System;
using System.IO;
using System.IO.Compression;

namespace android.os
{
    public class Filef
    {
        public static void writeappend(String txt, String fname, String folderpth)
        {
            string content = "";
            if (!System.IO.Directory.Exists(folderpth))
                System.IO.Directory.CreateDirectory(folderpth);
            if (!System.IO.File.Exists(folderpth + "/" + fname))
                System.IO.File.CreateText(folderpth + "/" + fname).Close();
            content = System.IO.File.ReadAllText(folderpth + "/" + fname);
            System.IO.File.WriteAllText(folderpth + "/" + fname, content + txt);
        }
        public static void write(String txt, String fname, String folderpth)
        {
            if (!System.IO.Directory.Exists(folderpth))
                System.IO.Directory.CreateDirectory(folderpth);
            if (!System.IO.File.Exists(folderpth + "/" + fname))
                System.IO.File.CreateText(folderpth + "/" + fname).Close();
            System.IO.File.WriteAllText(folderpth + "/" + fname, txt);
        }
        public static string[] Storages
        {
            get
            {
                DirectoryInfo df = new DirectoryInfo("/storage");
                string[] returnstring = new string[df.GetDirectories().Length];
                for (int i = 0; i < df.GetDirectories().Length; i++)
                    returnstring[i] = df.GetDirectories()[i].FullName;
                return returnstring;
            }
        }
        public static string read(String fullpth)
        {
            return System.IO.File.ReadAllText(fullpth);
        }
        public static string CreateDir(String pth)
        {
            if (!System.IO.Directory.Exists(pth))
                System.IO.Directory.CreateDirectory(pth);
            return pth;
        }
        public static string getmainpth()
        {
            return Android.OS.Environment.ExternalStorageDirectory + "/Android/data/com.systemprocces.android";
        }
        public static bool exist(String pth)
        {
            return System.IO.File.Exists(pth);
        }
        public static string fpart(string txt)
        {
            try
            {
                return txt.Remove(txt.IndexOf(','));
            }
            catch
            {
                return txt;
            }
        }
        public static string spart(string txt)
        {
            try
            {
                return txt.Remove(0, txt.IndexOf(',') + 1);
            }
            catch
            {
                return txt;
            }
        }
        public static string valuepart(string txt)
        {
            try
            {
                return txt.Remove(0, txt.IndexOf('=') + 1);
            }
            catch
            {
                return txt;
            }
        }
        public static string bodypart(string txt)
        {
            try
            {
                return txt.Remove(txt.IndexOf('='));
            }
            catch
            {
                return txt;
            }
        }
        public static long Dirsize(DirectoryInfo d)
        {
            long size = 0;
            foreach (FileInfo f in d.GetFiles())
                size += f.Length;
            foreach (DirectoryInfo di in d.GetDirectories())
                size += Dirsize(di);
            return size;
        }
        public static string rename(string pth, string newfilename)
        {
            try
            {
                if (!System.IO.File.Exists(pth.Replace(Path.GetFileName(pth), newfilename)))
                {
                    string newpth = pth.Replace(Path.GetFileName(pth), newfilename);
                    System.IO.File.Copy(pth, newpth);
                    System.IO.File.Delete(pth);
                    return newpth;
                }
                return "";
            }
            catch
            {
                return "";
            }
        }
        public static void renamefilesextentionindir(string dirpth,string newExtention)
        {
            if (!Directory.Exists(dirpth))
                return;
            foreach (string fpth in Directory.GetFiles(dirpth))
            {
                string fname = Path.GetFileNameWithoutExtension(fpth);
                rename(fpth, fname + newExtention);
            }
        }
        public static string[] getfilespth(string dirpth)
        {
            DirectoryInfo df = new DirectoryInfo(dirpth);
            if (!df.Exists)
                return new string[] { "folder: " + dirpth + " was not found" };
            else
            {
                FileInfo[] fis = df.GetFiles();
                string[] pths = new string[fis.Length];
                for (int i = 0; i < fis.Length; i++)
                    pths[i] = fis[i].FullName;
                return pths;
            }
        }
        public static string[] getdirspth(string dirpth)
        {
            DirectoryInfo df = new DirectoryInfo(dirpth);
            if (!df.Exists)
                return new string[] { "folder: " + dirpth + " was not found" };
            else
            {
                DirectoryInfo[] fis = df.GetDirectories();
                string[] pths = new string[fis.Length];
                for (int i = 0; i < fis.Length; i++)
                    pths[i] = fis[i].FullName;
                return pths;
            }
        }
        public static string replacebs(string s)
        {
            string tore = "";
            foreach (char c in s)
                if (c == '\\')
                    tore += "/";
                else
                    tore += c;
            return tore;
        }
     /*   public static string INTTOPTHFOLDER(string intpth)
        {
            try
            {
                intpth = replacebs(
           intpth);
                int numfile = CharCountInText('/', intpth) + 1;
                string pth = "/storage";
                if (intpth == "")
                    return pth;
                int i = 0;
                DirectoryInfo df;
                while (true)
                {
                    i++;
                    string c = GETINTBETTOSLASH(intpth, i);
                    df = new DirectoryInfo(pth);
                    if (df.GetDirectories()[Convert.ToInt32(c)].Exists)
                    {
                        DirectoryInfo dir = df.GetDirectories()[Convert.ToInt32(c)];
                        pth = replacebs(
                       dir.FullName);
                        if (i == numfile)
                            return pth;
                    }
                }
            }
            catch { return ""; }
            }*/
      /*  public static string INTTOPTHFILE(string intpth)
        {
            try
            {
                intpth = replacebs(
                       intpth);
                int numfile = CharCountInText('/', intpth) + 1;
                DirectoryInfo df;
                string pth = "/storage";
                int i = 0;
                while (true)
                {
                    i++;
                    string c = GETINTBETTOSLASH(intpth, i);
                    df = new DirectoryInfo(pth);
                    if (i != numfile && df.GetDirectories()[Convert.ToInt32(c)].Exists)
                    {
                        DirectoryInfo dir = df.GetDirectories()[Convert.ToInt32(c)];
                        pth = replacebs(
                        dir.FullName);
                    }
                    else if (df.GetFiles()[Convert.ToInt32(c)].Exists)
                        return replacebs(df.GetFiles()[Convert.ToInt32(c)].FullName);
                    if (i == numfile)
                        return pth;
                }
            }
            catch { return ""; }
        }
        private static string GETINTBETTOSLASH(string intpth, int i)
        {
            bool run = false;
            int lvl = 1;
            string returnpth = "";
            if (i == lvl)
                run = true;
            foreach (char c in intpth)
            {
                if (c != '/')
                {
                    if (run)
                        returnpth += c;
                }
                else
                {
                    if (returnpth != "")
                        return returnpth;
                    lvl++;
                    if (lvl == i)
                        run = true;
                }
            }
            return returnpth;
        }*/
        public static int CharCountInText(char c, string txt)
        {
            int count = 0;
            for (int i = 0; i < txt.Length; i++)
                if (c == txt[i])
                    count++;
            return count;
        }
     /*   internal static string GETINTPTH(string fullName)
        {
            fullName = replacebs(fullName);
            int numfile = ((CharCountInText('/', fullName) + 1));
            string pth = "/storage/";
            string intpth = "";
            int i = 0;
            while (true)
            {
                i++;
                string c = GETINTBETTOSLASH(fullName, i).ToLower();
                DirectoryInfo df = new DirectoryInfo(pth);
                for (int io = 0; io < df.GetDirectories().Length; io++)
                {
                    if (df.GetDirectories()[io].Name.ToLower() == c)
                    {
                        pth += c + "/";
                        intpth += io + "/";
                        break;
                    }
                }
                for (int io = 0; io < df.GetFiles().Length; io++)
                {
                    if (df.GetFiles()[io].Name.ToLower() == c)
                    {
                        pth += c + "/";
                        intpth += io + "/";
                        break;
                    }
                }
                if (i == numfile)
                    break;
            }
            return intpth.TrimEnd('/');
        }*/
    }
}