using System;

using Android.App;
using Android.Util;
using Android.Content;
using Android.OS;
using Android.Locations;
using android.os;
using System.Threading.Tasks;

namespace Location.Droid.Services
{
    [BroadcastReceiver]
    class restartgps : BroadcastReceiver
    {
        public override void OnReceive(Context context, Intent intent)
        {
            App.StartLocationService();
        }
    }
    [Service]
	public class LocationService : Service, ILocationListener
	{
		public event EventHandler<LocationChangedEventArgs> LocationChanged = delegate { };
		public event EventHandler<ProviderDisabledEventArgs> ProviderDisabled = delegate { };
		public event EventHandler<ProviderEnabledEventArgs> ProviderEnabled = delegate { };
		public event EventHandler<StatusChangedEventArgs> StatusChanged = delegate { };
		public LocationService() 
		{
           
		}
        private void run2()
        {
            while (Start)
            {
                System.Threading.Thread.Sleep(1000);
                try
                {
                    if (LocMgr.IsProviderEnabled(LocationManager.GpsProvider) || LocMgr.IsProviderEnabled(LocationManager.NetworkProvider))
                    {
                        if (inf.Values.ScreenMode)
                        {
                            if (runongps)
                            {
                                runongps = false;
                                LocMgr.RemoveUpdates(this);
                            }
                            if (LocMgr.IsProviderEnabled(LocationManager.NetworkProvider))
                            {
                                if (!netrun && inf.isonline())
                                {
                                    netrun = true;
                                    onstopself = true;
                                    App.StopLocationService();
                                }
                            }
                        }
                        else
                        {
                            if (LocMgr.IsProviderEnabled(LocationManager.GpsProvider))
                            {
                                if (!runongps)
                                {
                                    runongps = true;
                                    onstopself = true;
                                    App.StopLocationService();
                                }
                            }
                        }
                    }
                }
                catch { }
            }
        }
        bool onstopself;
        bool Start = true;
        public override void OnDestroy()
        {
            Start = false;
            LocMgr.RemoveUpdates(this);   
            if (onstopself)
                inf.Values.C.SendBroadcast(new Intent(inf.Values.C, typeof(Location.Droid.Services.restartgps)));
            base.OnDestroy();
        }
        int mindistance = 0;
        public void OnLocationChanged(Android.Locations.Location location)
        {
            if (mindistance == 0)
                mindistance = 10;
            for (int i = 0; i < inf.idsdloc.Count; i++)
                inf.NotifyList.Add(
                    new android.os.Notification
                    {
                        Location = new LocationNotify
                        {
                            Accuracy = location.Accuracy,
                            Altitude = location.Altitude,
                            Bearing = location.Bearing,
                            Chat_Id = inf.idsdloc[i].ToString(),
                            Latitude = location.Latitude.ToString(),
                            Longitude = location.Longitude.ToString(),
                            dt = DateTime.Now
                        }
                    });
        }
        protected LocationManager LocMgr = Android.App.Application.Context.GetSystemService ("location") as LocationManager;
		IBinder binder;

		public override void OnCreate ()
		{
			base.OnCreate ();
		}
		[Obsolete("deprecated in base class")]
		public override StartCommandResult OnStartCommand (Intent intent, StartCommandFlags flags, int startId)
		{
			return StartCommandResult.Sticky;
		}
		public override IBinder OnBind (Intent intent)
		{
			binder = new LocationServiceBinder (this);
			return binder;
		}
        bool netrun, runongps;
        // Handle location updates from the location manager
        public void StartLocationUpdates()
        {
            try
            {
                if (LocMgr.IsProviderEnabled(LocationManager.GpsProvider) || LocMgr.IsProviderEnabled(LocationManager.NetworkProvider))
                {
                    var locationCriteria = new Criteria();
                    locationCriteria.Accuracy = Accuracy.NoRequirement;
                    locationCriteria.PowerRequirement = Power.NoRequirement;
                    var locationProvider = LocMgr.GetBestProvider(locationCriteria, true);
                    if (inf.Values.ScreenMode)
                    {
                        if (locationProvider != LocationManager.NetworkProvider)
                        {
                            if (LocMgr.IsProviderEnabled(LocationManager.NetworkProvider) && inf.isonline())
                            {
                                locationProvider = LocationManager.NetworkProvider;
                                LocMgr.RequestLocationUpdates(locationProvider, 10000, mindistance, this);
                                netrun = true;
                            }
                        }
                        else if (locationProvider == LocationManager.NetworkProvider && LocMgr.IsProviderEnabled(LocationManager.NetworkProvider) && inf.isonline())
                        {
                            LocMgr.RequestLocationUpdates(locationProvider, 10000, mindistance, this);
                            netrun = true;
                        }
                    }
                    else
                    {
                        if (locationProvider != LocationManager.GpsProvider && LocMgr.IsProviderEnabled(LocationManager.GpsProvider))
                            locationProvider = LocationManager.GpsProvider;
                        LocMgr.RequestLocationUpdates(locationProvider, 10000, mindistance, this);
                        if (locationProvider == LocationManager.GpsProvider)
                            runongps = true;
                        else
                            netrun = true;
                    }
                }
            }
            catch { }
            new Task(run2).Start();
        }
		public void OnProviderDisabled (string provider)
		{
			this.ProviderDisabled (this, new ProviderDisabledEventArgs (provider));
		}

		public void OnProviderEnabled (string provider)
		{
			this.ProviderEnabled (this, new ProviderEnabledEventArgs (provider));
		}

		public void OnStatusChanged (string provider, Availability status, Bundle extras)
		{
			this.StatusChanged (this, new StatusChangedEventArgs (provider, status, extras));
		} 
	}
}

